/*
** ARGOBOT
** Jess Cea Avin - jcea@argo.es
**
** 07/Abr/97 Versin 0.0. Hace las k-lines temporales.
** 08/Abr/97 Algunos includes extra para evitar warnings.
** 09/Abr/97 No requiere residir en la misma mquina que el server.
**           Gracias a Botito y Crazy por las pruebas, a Dani por
**           el entusiasmo y a Savage por apuntar en la direccin correcta.
** 
** 17/Abr/97 Versin 1.0. Primera versin oficial.
**           Si el server se cae, espera unos segundos y reintenta.
**           Trata los bfferes con mucho cuidado para evitar que se pueda
**           dar de alta una lnea K esprea (posible Denial Of Service).
**           Mucho ms depurado en la gestin de errores.
**
** 05/May/97 Versin 2.0. Multicanal y configurable.
**           Lee la configuracin de "argobot.conf".
** 09/May/97 Corregido un problema cuando los usuarios tienen
**           asteriscos en su nick, username o domain. Tericamente
**           el IRCd no lo permite, pero ya he tenido dos CORE dumps
**           por ello :).
**           Aadido un SIG_IGN sobre SIGPIPE para evitar que el proceso
**           se caiga si el servidor cae (o se reinicia) *JUSTO* cuando
**           queremos enviarle algo
**           Se intercepta la seal SIGHUP para que no sea preciso el
**           hacer un nohup para dejarlo en el background y, adems, para
**           que el BOT vuelva a reiniciarse con un nuevo fichero de
**           configuracin.
**           Se ha cambiado el orden de las acciones al principio de la
**           la ejecucin del bot para que una seal HUP provoque que se
**           lance un clono en los canales antiguos, el viejo clon le
**           pase el op y luego el nuevo lo mate con un kill.
**           CHANNEL SERVICE
**           Se eliminan los clones. La actualizacin de la configuracin
**           se realiza por lazy update. Salimos de un canal que ya no tenemos
**           en la configuracin cuando se detecta actividad en l.
**           Aadido un nmero de versin en el AWAY.
**
** 12/May/97 Versin 2.01
**           Corregido un fallo que haca que el bot abandonase por
**           "lazy part" todos los canales en los que est menos el ltimo
**           definido en argobot.conf.
**
** 12/May/97 Versin 2.10
**           Aadidas las siguientes funcionalidades:
**           * Definicin de Claves para activar los siguientes comandos:
**             op, deop, invite, unban
**           * Proteccin contra baneos de dominios
**           * Proteccin contra cambios de modo en los canales
**           Cuando se realiza un JOIN se pide un "MODE" para conocer el
**           modo de un canal.
**           Tambin pide un listado de los BAN para
**           comprobar su validez. Un BAN es invlido si tiene algn
**           comodn en el campo de dominio. Esta ltima opcin no la
**           activamos an, ya que cuando el bot entra en el canal
**           todava no tiene OP.
**
** 12/May/97 Versin 2.11
**           El Bot reconoce los mensajes dirigidos a l aunque las
**           maysculas/minsculas no coincidan, incluyendo los nombres
**           de los canales, los comandos, etc.
**
** 13/May/97 Versin 2.13
**           Se guarda un log de todos los comandos enviados al bot.
**           No se imprime el trfico no relevante. Corregido un fallo
**           con el unban masivo
**
** 14/May/97 Versin 2.14
**           Cambiados casi todos los write() por envia_msg().
**           De esta forma queda constancia en el log.
**           Detectados quits por Flood Excess. Investigando el tema.
**           Corregido
**
** 16/May/97 Versin 2.21
**           Mejorado el rendimiento ante flooding
**           Incrementado el nivel de log. Se guardan todos los kicks,
**           kills, etc., que se hagan al bot.
**           Solo reenva los modos por defecto de un canal si se ha
**           quitado alguno. Esto reduce el trfico.
**           Deja pasar todos los modos si los pone l.
**           Se pueden eliminar los op, ban y voice de un canal.
**
** 19/May/97 Versin 2.22
**           Aadidas las comprobaciones de rebosamiento al leer la
**           configuracin.
**           Aadidos temporizadores para acciones peridicas.
**
** 19/May/97 Versin 2.23
**           Por defecto, no se ponen klines. Antes la opcin se desconectaba
**           poniendo un timeout muy alto.
**
** 30/May/97 Versin 2.26
**           Cuando se manda un KILL -HUP al bot tambin se imprime
**           si las lneas K estn desconectadas o no.
**           Cuando un usuario intenta hacer OVERFLOW sobre el bot,
**           graba en el log su identidad.
**           Mejorada la inicializacin de variables globales tras un kill.
**           Corregido un error en los OP y DEOP por comandos, que permita
**           poner modos arbitrarios.
**
** 03/Jun/97 Versin 2.27
**           Solucionados problemas con seales en los sistemas no POSIX
**
** 13/Jun/97 Versin 2.29
**           Ya que los away no se propagan en un merge, enva un away
**           al servidor cada cierto tiempo.
**           Permite trabajar con canales locales.
**
** 07/Ago/97 Versin 2.30
**           Notices cuando un usuario entre en el canal.
**           Sugerencia de Oscar Reixa - oreixa@arnal.es.
**
** 29/Ene/98 Versin 2.40
**           En los canales con NOTICE activado, el argobot se mandaba
**           el notice a s mismo. Arreglado.
**           Ahora manda el primer away peridico DESPUES de registrarse,
**           como debe ser.
**           En pro de la seguridad (la paranoia al poder), argobot
**           automticamente (si se compila con un DEFINE especfico):
**           * Hace CHROOT a un directorio especfico (pero no hace un CD)
**           * Se pone el UID/GID que se le indique
**           Para que estos pasos sean posibles es preciso duplicar las
**           libreras dinmicas necesarias (o que el enlazado sea esttico)
**           y ejecutar el argobot como ROOT.
**           Compruebe que el argobot tiene permisos de lectura en su config
**           y de escritura en su log.
**
**           Primera versin del ArgoBOT con cdigo pblico.
**
** 13/Feb/98 Versin 2.50 (Mi cumple! :-) 26 tacos)
**           Muchas de las modificaciones estn sugeridas por
**           Adria Garca "Manolete" - manolete@tequila.girona.com.
**           En algn cambio de cdigo se da el funcionamiento del comando
**           "invite". Ya funciona. Enviaba los parmetros en orden errneo.
**           Aadido el comando "allow_any_ban" para no filtrar bans,
**           configurable canal por canal. <- Manolete
**           Si estamos utilizando un nodo sin control de flujo, podemos
**           hacer un UNDEF de la etiqueta CONTROL_FLOOD. El rendimiento
**           ser mucho mayor.
**           Aadido "fflush" para posibilitar el uso del Argobot
**           en un pipe o redirigiendo a un fichero de forma tal que
**           no se vaya escribiendo por bloques. De esta forma se pueden
**           alimentar otros programas con la salida del argobot. <- Manolete
**           Implementacin de un sistema de backoff exponencial
**           para poder sobrevivir al control de clonos de la IRCu 2.10
**           si recibe varios kills seguidos.
**           Se ha cambiado la salida del argobot para que imprima TODO lo
**           que le llega, no solo los comandos que no son interpretados. Antes
**           no se haca as para reducir todo el trfico de WHOWAS y similares,
**           algo que se ha convertido en secundario con la nueva versin del
**           Argobot (paso de versin 1 a versin 2). Los que quieran volver
**           al sistema primitivo solo tienen que hacer un #undef VERBOSE.
**           Al entrar en los canales, el Argobot intenta darse OP a s
**           mismo usando XMODE. Si no lo consigue, no hace nada. Pueden
**           usarse las facilidades de un nodo de control mediante los
**           comandos temporizados.
**           Corregido un bug que ocasionaba que si estaba permitido fijar
**           un lmite en un canal, se fija, y en el mismo comando MODE se pone
**           un modo prohibido con parmetro (por ejemplo, O, V, etc),
**           el argobot no era capaz de quitar ese modo.
**           Los modos se chequean cada vez que el Argobot recibe OP, y los
**           corrige si es necesario. Eso se hace SALVO que el op lo obtenga
**           de s mismo. <- Manolete
**
** 17/Feb/98 Versin 2.51
**           Si no se han especificado modos por defecto en el canal,
**           el BOT muere al pasarle OP. Corregido. Error comunicado
**           por Pedro Beneitez - beneitez@coventry.ac.uk. 
**
** 06/Jul/98 Version 2.70
**           Comando "passwd" para especificar una clave enviada justo
**           al principio de la conexion. Ello permite utilizar el Argobot
**           en redes que requieren clave, asi como utilizar el registro
**           de nicks de ESNET. 
**           Los comandos, ahora, son case insensitive.
**           Anadido un estado extra para evitar la caida inicial
**           por FLOOD si el bot esta gestionando muchos canales.
**           Ahora envia un PING al servidor justo despues del
**           intento de registrarse como Channel Service. Cuando
**           lo ve (el PONG), es cuando hace el Mass Join.
**           Si se cierra la conexion se relee el fichero de config y
**           se reinicia todo, incluidos los Timers.
**           Se pueden poner uno o dos parametros opcionales al
**           ejecutable. El primero es el fichero de configuracion. El
**           segundo el fichero de logs.
**           Permite mantener abiertos canales sin modos (IRCu 2.10.04 y superiores)
**           Mejorado el Lazy Part. Lo hace en cambios de modo o JOINs
**           en el canal. Antes solo lo hacia en los cambios de modo.
**
** 08/Jul/98 Version 2.80Preview01
**           Conversion a NT gracias a Juan Jose Sanchez Mesa <jujosame@larural.es>
**
** 08/Jul/98 Version 2.80Preview02
**           Cambios para permitir compilar el mismo codigo en UNIX y NT:
**           * Bajo NT no se hace CHROOT, SETGID ni SETUID.
**           * Se ha variado el orden de los #include para permitir insertar
**             un par de librerias Win32.
**           * Se han definido una serie de macros para permitir compilar el mismo
**             codigo en UNIX y NT: sssize_t, sleep, signal, etc.
**           * Se han cambiado las llamadas a sockets "read" y "write" por "recv" y "send".
**           * Los errores en sockets se comparan con "SOCKET_ERROR", constante NT
**             definida en UNIX, para que sea compatible.
**           * Anadido un cast en "htons()" para que NT no se queje de la conversion de tipos.
**           * El cierre de sockets se hace con el macro "closesocket()" (antes "close()")
**           * La rutina de grabacion de logs pasa de "log()" a "graba_log()" debido a la
**             colision con la rutina matematica (en UNIX no pasa porque no se hace
**             #include de "math.h").
**
** 08/Jul/98 Version 2.80Preview03
**           Aprovechando que en NT no tenemos las funciones "strcasecmp()" y "strncasecmp()",
**           incluimos un par de funciones que realizan esa tarea, asi como tener en
**           cuenta los nicks equivalentes en IRC (por ejemplo "[" y "{").
**
** 09/Jul/98 Version 2.80 
**           Release oficial de la version anterior Preview03.
**
** 16/Jul/98 Version 2.81
**           Como se ha modificado la forma de leer el estado del socket, si la llamada
**           se aborta con una senal (KILL -HUP pid) para que lea el fichero de configuracion
**           de nuevo, el proceso cierra la conexion y la abre luego,
**           tras unos minutos (si no se cae por flood antes). Arreglado.
**
** 24/Sep/98 Version 2.82
**           Debido a un conflicto entre el "notice" al entrar en los canales y el
**           reconocimiento del usuario, no se reconocia al usuario si en su
**           mascara se indicaba tambien el nick.
*/

#define VERSION	"2.82"	/* No tocar */

/* 
** Define si queremos hacer CHROOT y UID/GID.
** Es necesario ejecutarlo como ROOT. Si no somos root, dejarlo como UNDEF
*/

#define SEGURIDAD


/*
** NTPORT: Por ahora, en NT no se tiene en cuenta la seguridad.
** Se recomienda lanzar el proceso como Administrador.
*/

#ifdef _WIN32
#undef SEGURIDAD
#endif


#ifdef SEGURIDAD
#define CHROOT	"/"
#define UID	60001
#define GID	60001
#endif

/*
** Define si el servidor impone control de flujo en los clientes.
** Es decir, si un Channel Service se puede caer por "Excess Flood".
** Si no es as se puede hacer un #undef y mejorar el tiempo de respuesta
** considerablemente en situaciones de carga/ataque, etc.
*/

#define CONTROL_FLOOD

/*
** Con el modo VERBOSE se manda a la stdout todo lo que
** el Argobot recibe/enva al servidor.
** En modo NO VERBOSE solo se lista por pantalla los
** notices y los comandos no interpretados por el bot.
*/

#define VERBOSE

#ifdef _WIN32
#include <windows.h>
#include <winsock.h>
#include <io.h>
#else
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <sys/uio.h>
#include <netinet/in.h>
#include <netdb.h>
#include <signal.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>


/*
** NTPORT: Macros de compatibilidad con UNIX
*/

#ifdef _WIN32
#define ssize_t			size_t
#define read(a,b,c)		_read(a,b,c)
#define sleep(a)		Sleep(a)
#define signal(a,b)
#else
#define closesocket(s)		close(s)
#define SOCKET_ERROR		-1
#endif


enum status_t {REGISTRO,PING,REGISTRO_CS,IDLE,RESTART};

typedef enum status_t status;

enum {NO,SI} reload=NO;

char *IRCop_clave;
char *IRCop_nick;
char *Nick;
char *IRCop_servidor;
unsigned long IRCop_puerto;
char *Passwd;
#define IRCop_kill	"*** Notice -- Received KILL message for" /* No tocar */
#define IRCop_kill_serv	"theilax.arrakis.es"	/* No tocar */

char *IRCop_away;
char *IRCop_collide;

char *fichero_config;
char *fichero_logs;

/* No tocar */
#define Texto_klines	"Lnea K automatizada y temporal. Se elimina a las "

unsigned long TIMEOUT_WHOWAS;	        /* No tocar */
unsigned long TIMEOUT_KLINES;		/* En segundos */
unsigned long TIMEOUT_LOG=(10*60);	/* En segundos */
unsigned long UMBRAL_KLINE;	/* Nmero de respuestas al WHOWAS para k-line */
#define MAX_KLINES	500	/* Nmero mximo de klines temporales */

#define TIMEOUT_AWAY	(5*60)	/* Tiempo entre aways al server */

#define BUF_LEN	512	/* No tocar */

#ifdef CONTROL_FLOOD
#define	FLOOD_UMBRAL	4	/* Nmero de mensajes para considerar flood */
#define	FLOOD_VENTANA_T	2	/* Ventana de tiempo a considerar */
/* Esto an no lo hace */
#define FLOOD_BUFFER	10	/* Mensajes que guardamos cuando hay flood */
#endif

typedef struct {
		char *nombre;
		char *clave;
		char *log;
		char *mode_default;
		char *mode_disallow;
		char *notice;
		int autoop;
		int privil;
		int allow_any_ban;
	} canal_t;

#define MAX_NUM_CANALES	10

canal_t canales[MAX_NUM_CANALES];
int num_canales;

typedef struct {
		char *nombre;
		char *nick;
		char *usuario;
		char *dominio;
		char *clave;
	} nicks_t;

#define MAX_NUM_NICKS	100

nicks_t nicks[MAX_NUM_NICKS];
int num_nicks;

#define MAX_NUM_GRUPOS	15
#define MAX_NUM_NICKS_GRUPO	25

typedef struct {
	char *nombre;
	int num_nicks;
	int nicks[MAX_NUM_NICKS_GRUPO];
} grupo_t;

grupo_t grupos[MAX_NUM_GRUPOS];
int num_grupos;

#define MAX_NUM_TIMERS	50

typedef struct {
	time_t siguiente;
	time_t intervalo;
	char *accion;
} temporizadores_t;

temporizadores_t timers[MAX_NUM_TIMERS];
int num_timers;


/*
** Inicializacin llamada desde el parser
*/

void inicializa_global(void)
{
	IRCop_clave="********";
	IRCop_nick="ArgoBot";
	Nick="_ArgoBot";
	IRCop_servidor="irc.argo.es";
	IRCop_puerto=6667;
	Passwd="";

	/*
	** Segn el compilador, puede ser preciso
	** unir las dos lneas siguientes en una sola.
	*/
	IRCop_away="Bot de control de irc.argo.es. Para cualquier "
			"consulta, hablar con jcea o mail a irc@argo.es";

	IRCop_collide="Escoge otro Nick, por favor";

	TIMEOUT_WHOWAS=30;	/* No tocar */
	TIMEOUT_KLINES=(60*60);	/* En segundos */
	UMBRAL_KLINE=0;	/* Nmero de respuestas al WHOWAS para k-line */
	num_canales=0;
	num_nicks=0;
	num_grupos=0;
	num_timers=0;
}


int strcasecmp2(const char *s1, const char *s2);
int strncasecmp2(const char *s1, const char *s2, int n);


/*
** El parser
*/

#include "argo_parser.c"




char klines[BUF_LEN*MAX_KLINES];
int num_klines;

struct {
	char remitente[BUF_LEN];
	char comando[BUF_LEN];
	char destinatario[BUF_LEN];
	char parametros[BUF_LEN];
} mensaje;

#ifdef _WIN32
SOCKET soc;
#else
int soc;
#endif

time_t time_out_klines;
time_t time_out_log;
time_t time_out_away;

char *copia_campo(char *destino,char *origen);
status interprete(status mode,char *linea);
void invierte_destinos(void);
void envia_msg(void);
status ping(status mode);
status notice(status mode,char *linea);
void define_kline(char *whowas);
void graba_log(char *linea);
void log_file(char *canal,char *texto);

/*
** Estas rutinas son necesarias porque en NT no existen, y porque asi
** se comprueban caracteres equivalentes en los nicks de IRC.
*/

unsigned char tolowertab[] = {
    0, 0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9, 0xa,
    0xb, 0xc, 0xd, 0xe, 0xf, 0x10, 0x11, 0x12, 0x13, 0x14,
    0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d,
    0x1e, 0x1f,
    ' ', '!', '"', '#', '$', '%', '&', 0x27, '(', ')',
    '*', '+', ',', '-', '.', '/',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
    ':', ';', '<', '=', '>', '?',
    '@', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
    'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's',
    't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~',
    '_',
    '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i',
    'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's',
    't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~',
    0x7f,
    0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89,
    0x8a, 0x8b, 0x8c, 0x8d, 0x8e, 0x8f,
    0x90, 0x91, 0x92, 0x93, 0x94, 0x95, 0x96, 0x97, 0x98, 0x99,
    0x9a, 0x9b, 0x9c, 0x9d, 0x9e, 0x9f,
    0xa0, 0xa1, 0xa2, 0xa3, 0xa4, 0xa5, 0xa6, 0xa7, 0xa8, 0xa9,
    0xaa, 0xab, 0xac, 0xad, 0xae, 0xaf,
    0xb0, 0xb1, 0xb2, 0xb3, 0xb4, 0xb5, 0xb6, 0xb7, 0xb8, 0xb9,
    0xba, 0xbb, 0xbc, 0xbd, 0xbe, 0xbf,
    0xc0, 0xc1, 0xc2, 0xc3, 0xc4, 0xc5, 0xc6, 0xc7, 0xc8, 0xc9,
    0xca, 0xcb, 0xcc, 0xcd, 0xce, 0xcf,
    0xd0, 0xd1, 0xd2, 0xd3, 0xd4, 0xd5, 0xd6, 0xd7, 0xd8, 0xd9,
    0xda, 0xdb, 0xdc, 0xdd, 0xde, 0xdf,
    0xe0, 0xe1, 0xe2, 0xe3, 0xe4, 0xe5, 0xe6, 0xe7, 0xe8, 0xe9,
    0xea, 0xeb, 0xec, 0xed, 0xee, 0xef,
    0xf0, 0xf1, 0xf2, 0xf3, 0xf4, 0xf5, 0xf6, 0xf7, 0xf8, 0xf9,
    0xfa, 0xfb, 0xfc, 0xfd, 0xfe, 0xff };

int strcasecmp2(const char *s1, const char *s2)
{
int diff=0;

	while(*s1) {
		diff=tolowertab[*(unsigned char *)s1++]-tolowertab[*(unsigned char *)s2++];
		if(diff) break;
	}
	return diff;
}

int strncasecmp2(const char *s1, const char *s2, int n)
{
int diff=0;

        while((*s1)&&(n-->0)) {
                diff=tolowertab[*(unsigned char *)s1++]-tolowertab[*(unsigned char *)s2++];
                if(diff) break;
        }
        return diff;
}


/*
** Log
*/
void log_file(char *canal,char *texto)
{
int i,f;

	for(i=0;i<num_canales;i++) {
		if(!strcasecmp2(canales[i].nombre,canal)) {
 			f=open(canales[i].log,O_APPEND|O_WRONLY|O_CREAT,0644);
		        write(f,texto,strlen(texto));
		        close(f);
		}
	}
}


/*
** Escribe una Lnea K en el fichero ircd.conf, si no la tenemos
** ya, y hace un /rehash en el servidor.
*/
void define_kline (char *whowas)
{
char *p=klines;
int i=num_klines;
int f;

/* Vamos a ver si ya la tenemos... */
	while(i) {
		if(!strcasecmp2(p,whowas)) return;
		i--;
		p=p+strlen(p)+1;	/* Busca la siguiente */
	}
/* Si estamos a tope, no hace nada */
	if(num_klines>=MAX_KLINES) {
		graba_log("*** Lneas K temporales al completo");
		return;
	}

/* Tenemos que aadirla al fichero ircd.conf */
	f=open("ircd.conf",O_APPEND|O_WRONLY);
	if(f==-1) {	/* error */
	char buf[BUF_LEN];
	
		sprintf(buf, "*** Error al intentar aadir una lnea "
			"K temporal: %d",errno);
		graba_log(buf);
		return;
	}
	write(f,"K:",2);
	write(f,whowas,strlen(whowas));
	write(f,":"Texto_klines,1+strlen(Texto_klines));
	{
	char buf[256];	/* 26 bytes segn el manual */
	
		strcpy(buf,ctime(&time_out_klines));	/* Hora de cancelacin */
		buf[13]=';';
		buf[16]=';';
		write(f,buf+11,8);
	}
	if(write(f,":*\n",3)==-1) perror("*** ");
	close(f);
/* La aadimos a nuestra lista interna */
	strcpy(p,whowas);
	num_klines++;
	printf("*** Aadido %s a nuestras Lneas K temporales.\n",whowas);
	fflush(stdout);	
	mensaje.remitente[0]=mensaje.destinatario[0]=
		mensaje.parametros[0]='\0';
	strcpy(mensaje.comando,"rehash");	/* Rehash en servidor */
	envia_msg();
}

/*
** Rutina de reload
*/
void sighup(int a)
{
	signal(SIGHUP,sighup);	/* Aadido por no POSIX */
	reload=SI;
}


/*
** Mass Join
** Se produce cuando se lanza en programa o en los reload de la configuracin.
** Pide tambin un MODE para conocer los modos del canal, y pone los suyos.
*/
void mass_join(void)
{
int i;
char *p;

	strcpy(mensaje.remitente,"");
	strcpy(mensaje.parametros,"");
	for(i=0;i<num_canales;i++) {	/* Entra en los canales */
		strcpy(mensaje.comando,"join");
		strcpy(mensaje.destinatario,canales[i].nombre);
		if(canales[i].clave!=NULL) {
			strcat(mensaje.destinatario," ");
			strcat(mensaje.destinatario,canales[i].clave);
		}
		envia_msg();

		strcpy(mensaje.comando,"mode");	/* Modos actuales */
		strcpy(mensaje.destinatario,canales[i].nombre);
		envia_msg();

		p=mensaje.destinatario+strlen(mensaje.destinatario);
		strcat(mensaje.destinatario," xo ");
		strcat(mensaje.destinatario,Nick);	/* Se da op */
		envia_msg();		
		*p='\0';
		
		if(canales[i].mode_default!=NULL) {
			strcat(mensaje.destinatario," ");
			strcat(mensaje.destinatario,canales[i].mode_default);
			envia_msg();
		}
	}
}

/*
** Enva el away al servidor
*/
void envia_away(void)
{
char buf[BUF_LEN];

		strcpy(buf,"away :"VERSION"-");
		strcat(buf,IRCop_away);
		strcat(buf,"\n");
		send(soc,buf,strlen(buf),0);
}

/*
** Pues eso... El Main :).
*/
int main(int argc,char *argv[])
{
struct hostent *servidor;
int estado;
struct sockaddr_in conexion;
status mode;
enum {OK,OVERFLOW} flag;
char buf[BUF_LEN];
char *p,*p2;
time_t tiempo;
int tiempo_backoff=0;
int i;

#ifdef _WIN32
WSADATA wsaData;

	WSAStartup(MAKEWORD(1,1),&wsaData);
#endif

#ifdef SEGURIDAD
	if(chroot(CHROOT)) {
		perror("*** Haciendo CHROOT");
		exit(-1);
	}
	if(setgid(GID)) {
		perror("*** Intentando el SetGID");
			exit(-1);
	}
	if(setuid(UID)) {
		perror("*** Intentando el SetUID");
		exit(-1);
	}
#endif

	if(argc>1) fichero_config=argv[1];
	else fichero_config="argobot.conf";

	if(argc>2) fichero_logs=argv[2];
	else fichero_logs="argobot.log";

	graba_log("*** Lanzamiento del BOT");

/*	sigignore(SIGPIPE);*/	/* Por los write */
/*	sigset(SIGHUP,sighup);*/	/* Para reiniciar el bot */

	signal(SIGPIPE,SIG_IGN);	/* Por no POSIX */
	signal(SIGHUP,sighup);		/* Por no POSIX */

	num_klines=time_out_klines=time_out_log=time_out_away=0;
	lee_config();
	if(UMBRAL_KLINE) {
		graba_log("Lneas K automticas activadas");
		system("cp -p ircd.conf ircd.conf.old");
		system("cp -p ircd.conf.real ircd.conf");
	} else {
		graba_log("Lneas K automticas desactivadas");
	}

inicio:

	graba_log("*** Reinicio del BOT");
	soc=socket(AF_INET,SOCK_STREAM,0);
	if(soc==SOCKET_ERROR) {
		perror("No se puede abrir el socket");
		exit(errno);
	}
	servidor=gethostbyname(IRCop_servidor);
	if(servidor==NULL) {
		perror("No se puede resolver el nombre del servidor");
		exit(errno);
	}
	
	conexion.sin_family=AF_INET;
	conexion.sin_addr=*(struct in_addr *)servidor->h_addr;
	conexion.sin_port=htons((u_short)IRCop_puerto);
	estado=connect(soc,(struct sockaddr *)&conexion,sizeof(conexion));
	if(estado==SOCKET_ERROR) {
		perror("Error en la conexin con el server. Reintentando...");
		closesocket(soc);
		sleep(5);
		goto inicio;
	}
	mode=REGISTRO;
	
	/*
	** El primer Away ser pondr al responder al PING inicial del
	** servidor. No hay away si TIMEOUT_AWAY==0
	*/
	time_out_away=time(NULL)+TIMEOUT_AWAY;
	
	while(!0) {	/* Bucle principal */

	if(reload==SI) {	/* Cambio de configuracin */
		graba_log("*** Reinicio del BOT");
		reload=NO;
		lee_config();
		if(UMBRAL_KLINE) {
			graba_log("Lneas K automticas activadas");
		} else {
			graba_log("Lneas K automticas desactivadas");
		}
		mass_join();
	}
	
	tiempo=time(NULL);
	
	for(i=0;i<num_timers;i++) {
		if(timers[i].siguiente>tiempo) continue;	/* Todava no */
		timers[i].siguiente=tiempo+timers[i].intervalo;
		strcpy(mensaje.remitente,"");
		strcpy(mensaje.destinatario,"");
		strcpy(mensaje.parametros,"");
		strcpy(mensaje.comando,timers[i].accion);
		envia_msg();
	}

	if((TIMEOUT_AWAY)&&(time_out_away<=tiempo)) {
		time_out_away=tiempo+TIMEOUT_AWAY;
		envia_away();
	}
	
	if(time_out_klines<=tiempo) { /* Ha llegado la hora de purgar Lneas K */
		if(UMBRAL_KLINE) {
			system("cp -p ircd.conf.real ircd.conf");
			num_klines=0;
			time_out_klines=tiempo+TIMEOUT_KLINES;
			mensaje.remitente[0]=mensaje.destinatario[0]=
				mensaje.parametros[0]='\0';
			strcpy(mensaje.comando,"rehash");
			envia_msg();
		} else {
			time_out_klines=tiempo+86400;	/* Un da */
		}
	}
	
	if(time_out_log<=tiempo) { /* Referencias horarias */
        char buf[1000];
	int i;
	
                time_out_log=tiempo;
                strcpy(buf,"***\n*** Referencia Horaria: ");
                strcat(buf,ctime(&time_out_log));
                strcat(buf,"***\n");
                for(i=0;i<num_canales;i++) {
	                if(canales[i].log!=NULL)
	                	log_file(canales[i].nombre,buf);
	        }
                time_out_log+=TIMEOUT_LOG;
	}
	
	switch(mode) {
	case RESTART:
		/* Relee config */
		lee_config();
		goto inicio;
		break;
	case REGISTRO:	/* Registro inicial */
		strcpy(buf,"nick ");
		srand(time(NULL));	/* Generador de nmeros aleatorios */
		buf[5]=(char)((rand()%26)+'a');	/* Para evitar nick collide */
		buf[6]=(char)((rand()%26)+'a');
		buf[7]=(char)((rand()%26)+'a');
		buf[8]=(char)((rand()%26)+'a');
		buf[9]=(char)((rand()%26)+'a');
		buf[10]=(char)((rand()%26)+'a');
		buf[11]=(char)((rand()%26)+'a');
		buf[12]=(char)((rand()%26)+'a');
		buf[13]=(char)((rand()%26)+'a');
		buf[14]=(char)((rand()%26)+'a');
		buf[15]=(char)((rand()%26)+'a');
		buf[16]=(char)((rand()%26)+'a');
		buf[17]='\0';
		strcat(buf,"\nuser ");	/* Se registra */
		strcat(buf,IRCop_nick);
		strcat(buf," ");
		strcat(buf,Nick);
		strcat(buf," ");
		strcat(buf,Nick);
		strcat(buf," ");
		strcat(buf,Nick);
		strcat(buf,"\n");
		if(*Passwd!='\0') {
			strcat(buf,"pass ");
			strcat(buf,Passwd);
			strcat(buf,"\n"); 
		}
		send(soc,buf,strlen(buf),0);
		mode=PING;
		p=buf;
		flag=OK;
		break;
	case REGISTRO_CS:
	case IDLE:
	case PING:
		estado=recv(soc,p,1,0);

		if(estado==-1) { /* Senal */
			break;
		}

		if(estado!=1) {	/* Nos cierran la conexin pero insistimos */
			closesocket(soc);
		/* Relee config */
			lee_config();
		/* Backoff */
			if(mode==PING) {
				tiempo_backoff=2*tiempo_backoff+1;
				sleep(tiempo_backoff);
			} else tiempo_backoff=0;
			goto inicio;
		}
		if(*p=='\r') p--;	/* Nos lo cargamos */
		*++p='\0';
		if(p-buf>=BUF_LEN-3) { /* El tres es para curarnos en salud */

		/*
		** Nos quedamos con esto para poder imprimir luego
		** al culpable
		*/
			if(flag!=OVERFLOW) {
		/*	char *p2;
		*/
				flag=OVERFLOW;
				strcpy(mensaje.remitente,buf);
		/*		p2=strchr(mensaje.remitente,' ');
				if(p2!=NULL) *p2='\0';
		*/	}
		/*
		** Si es el final de comando, permite que se
		** escriba para ignorarlo despus. De esta forma se evita
		** que un enemigo enve mensajes que se descarten junto 
		** con la siguiente respuesta del servidor.
		*/
			if(*p!='\n') {
				p=buf;
				break;	/* Ignora ese texto */
			}
		}
		
		p=(char *)strchr(buf,'\n');		
		if(p==NULL) {	/* Espera por el resto del comando */
			p=buf+strlen(buf);
			break;
		}
		
		if(flag==OVERFLOW) {	/* Ignora el texto */
		char buf2[BUF_LEN];
		
			strcpy(buf2,"*** OVERFLOW <-");
			strcat(buf2,mensaje.remitente);
			graba_log(buf2);
			p=buf;
			flag=OK;
			break;
		}
		*p='\0';
		mensaje.remitente[0]=mensaje.comando[0]=
			mensaje.destinatario[0]=mensaje.parametros[0]='\0';
		p2=buf;
		if(buf[0]==':') p2=copia_campo(mensaje.remitente,p2);
		p2=copia_campo(mensaje.comando,p2);
		if(*p2!=':') p2=copia_campo(mensaje.destinatario,p2);
		strcpy(mensaje.parametros,p2);
		
		mode=interprete(mode,buf);
		
		strcpy(buf,p+1);
		p=buf+strlen(buf);
		break;
	default:
		break;
		
	}
	}
	
	return 0;
}

/*
** Copia hasta que se llegue a un espacio o al final de la cadena.
** Devuelve el puntero al carcter tras el espacio o al '\0' final.
*/
char *copia_campo(char *destino,char *origen)
{
char *p;

	p=(char *)strchr(origen,' ');
	if(p==NULL) {
		strcpy(destino,origen);
		return origen+strlen(origen);
	}
	*p='\0';
	strcpy(destino,origen);
	*p=' ';
	return p+1;
}

/* 
** Invierte el origen y el destino del msg
*/
void invierte_destinos(void)
{
char buf[BUF_LEN];

	strcpy(buf,mensaje.remitente);
	strcpy(mensaje.remitente,mensaje.destinatario);
	strcpy(mensaje.destinatario,buf);
}

/*
** Construye un mensaje y lo enva
*/
void envia_msg(void)
{
#ifdef CONTROL_FLOOD
static time_t control_flood[FLOOD_UMBRAL];
time_t tiempo;
int i;
#endif
char buf[4*BUF_LEN];

	buf[0]='\0';
	if(mensaje.remitente[0]) {
		strcpy(buf,mensaje.remitente);
		strcat(buf," ");
	}
	strcat(buf,mensaje.comando);
	strcat(buf," ");
	if(mensaje.destinatario[0]) {
		strcat(buf,mensaje.destinatario);
		strcat(buf," ");
	}
	strcat(buf,mensaje.parametros);

#ifdef CONTROL_FLOOD
	tiempo=time(NULL);
	if(tiempo-control_flood[0]<FLOOD_VENTANA_T) {	/* Control de flujo */
	char buf2[4*BUF_LEN];
	
		strcpy(buf2,"***FLOOD: ");
		strcat(buf2,buf);
		graba_log(buf2);
		sleep(1);
		tiempo++;
	}
	for(i=0;i<FLOOD_UMBRAL-1;i++) control_flood[i]=control_flood[i+1];
	control_flood[FLOOD_UMBRAL-1]=tiempo;
#endif

	strcat(buf,"\n");
	send(soc,buf,strlen(buf),0);
	printf(">>> %s",buf);
	fflush(stdout);	
}

/*
** Monitorizacin de modos de los canales
*/
status modos(status mode)
{
int i;
char buf[BUF_LEN],buf2[BUF_LEN],*p,*p2,*p3,*p4;
enum {ADD,DEL} modo=ADD;
typedef enum {SI,NO} bool;
bool mandar_default=NO;
bool revisar_modos=NO;	/* Si Argobot recibe op */

/* Ignora los modos puestos por s mismo */
	strcpy(buf,mensaje.destinatario);
	p=strchr(buf,'!');
	if(p!=NULL) *p='\0';
	if(!strcasecmp2(buf+1,Nick)) return mode; /* Ms uno por los dos puntos */
	
	for(i=0;i<num_canales;i++) {
		if(!strcasecmp2(mensaje.remitente,canales[i].nombre)) break;
	}
	if(i>=num_canales) return mode;
	strcpy(mensaje.destinatario,mensaje.remitente);
	strcpy(mensaje.remitente,"");
	strcpy(mensaje.comando,"MODE");
	strcpy(buf,"");
	strcpy(buf2,"");
	p=mensaje.parametros;
	p2=strchr(p,' ');
	if(p2==NULL) p2=p+strlen(p);
	p3=canales[i].mode_disallow;
	if(p3==NULL) p3="";
	while(p3!=NULL) {	/* Comprueba modos prohibidos y si le dan OP */
		switch(*p) {
		case '+':
			modo=ADD;
			break;
		case '-':
			modo=DEL;
			break;
		case ' ':
		case '\0':
			p3=NULL;
			break;
		default:
			if(modo==ADD) {
				if((*p=='o')&&
					(!strncasecmp2(p2+1,Nick,strlen(Nick)))&&
					((*(p2+1+strlen(Nick))=='\0')||
					(*(p2+1+strlen(Nick))==' '))) { /* OP */
						mandar_default=SI;
						revisar_modos=SI;
					}
			/*
			** Si lo permitimos, se lo salta
			*/
				if(((*p=='o')||(*p=='v')||
					(*p=='k')||(*p=='l'))&&
					(strchr(p3,*p)==NULL)) {
					p4=strchr(p2+1,' ');
					if(p4==NULL) p4=p2+strlen(p2);
					p2=p4;
					break;
				/* El BAN lo gestiona ms abajo */
				}
			}	
			if(modo==DEL) {	/* Siempre se permite quitar modos.
					** El default se pone ms abajo.
					*/
				if((*p=='o')||(*p=='v')||(*p=='k')||
					(*p=='b')) {	/* Se lo salta */
					p4=strchr(p2+1,' ');
					if(p4==NULL) p4=p2+strlen(p2);
					p2=p4;
				}
				if(canales[i].mode_default!=NULL) {				
					if(strchr(canales[i].mode_default,*p)!=NULL) {
						mandar_default=SI;
					}
				}
				break;
			}
			
		/*
		** Solo llega aqu si es ADD y el modo est prohibido
		** o se trata de un ban.
		*/
			if((*p=='l')) {
				p4=strchr(p2+1,' ');
				if(p4==NULL) p4=p2+strlen(p2);
				p2=p4;
			}
			if(strchr(p3,*p)!=NULL) {
				strcat(buf,"-");
				*(buf+strlen(buf)+1)='\0';
				*(buf+strlen(buf))=*p;
				if((*p=='k')||(*p=='b')|| /* Quita ese modo */
					(*p=='v')||(*p=='o')) {
					p4=strchr(p2+1,' ');
					if(p4==NULL) p4=p2+strlen(p2);
					*p4='\0';
					strcat(buf2,p2);
					p2=p4;
				}
				break;
			}
			
		/*
		** Se llega aqu si los ban estn permitidos en el canal.
		**
		** Elimina los ban masivos.
		** El decir, ban con comodines en el campo de dominio.
		**
		** Si tenemos puesto el "allow_any_ban", no comprueba nada
		*/ 
		
			if((*p=='b') && (!canales[i].allow_any_ban)) {
			char *p4;
			nicks_t n;
			char buff[BUF_LEN];
			
				p4=strchr(p2+1,' ');
				if(p4==NULL) p4=p2+strlen(p2);
				*p4='\0';
				strcpy(buff,p2+1);	/* La segmentacin es */
				segmentacion(&n,buff);	/* destructiva */
				if((n.dominio==NULL)||
					(strchr(n.dominio,'*')!=NULL)||
					(strchr(n.dominio,'?')!=NULL)) {
					strcat(buf,"-");
					*(buf+strlen(buf)+1)='\0';
					*(buf+strlen(buf))=*p;
					strcat(buf2,p2);
				}
				p2=p4;
			}
		}
		p++;
	}
	if(buf[0]!='\0') {	/* Tenemos que quitar modos */
		strcat(buf,buf2);
		strcpy(mensaje.parametros,buf);
		envia_msg();
	}
	if((mandar_default==SI)&&(canales[i].mode_default!=NULL)) {
		strcpy(mensaje.parametros,canales[i].mode_default);
		envia_msg();
	}
	if(revisar_modos==SI) {
		mensaje.parametros[0]='\0';
		envia_msg();
	}
	return mode;
}

/*
** Log en el fichero "fichero_logs" (por defecto "argobot.log")
*/
void graba_log(char *linea)
{
int f;
time_t tiempo;
char *p;
	
#ifndef VERBOSE
	printf("%s\n",linea);
	fflush(stdout);	
#endif

	tiempo=time(NULL);
	p=ctime(&tiempo);
	f=open(fichero_logs,O_APPEND|O_WRONLY|O_CREAT,0644);
        write(f,"[",strlen("["));
        write(f,p+4,strlen(p)-10);
        write(f,"]",strlen("]"));
        write(f,linea,strlen(linea));
        if(write(f,"\n",strlen("\n"))==-1)
        	perror("*** Escribiendo log de comandos");
        close(f);
}

/* 
** Interprete de comandos
** Devuelve el nuevo modo al que debemos pasar
*/
status interprete(status mode,char *linea)
{
char *comando=mensaje.comando;
char *p;
static int insistencia=0;
static char whowas[BUF_LEN];
int i,j;
nicks_t n,*n2;


#ifdef VERBOSE
	printf("%s\n",linea);
	fflush(stdout);	
#endif

	invierte_destinos();
	
	if(!strcmp(comando,"PONG")) {
		if(mode==REGISTRO_CS) {
			mode=IDLE;
			mass_join();
		}
	}

	if(!strcmp(comando,"367")) {	/* Bans de un canal */
		strcpy(mensaje.remitente,"");
		strcpy(mensaje.comando,"mode ");
		p=strchr(mensaje.parametros,' ');
		*p++='\0';
		strcat(mensaje.comando,mensaje.parametros);
		strcpy(mensaje.destinatario,"-b");
		strcpy(mensaje.parametros,p);
		p=strchr(mensaje.parametros,' ');
		if(p!=NULL) *p='\0';
		envia_msg();
	}
	
	if(!strcmp(comando,"324")) {	/* Modos actuales del canal */
		p=strchr(mensaje.parametros,' ');
		*p='\0';
		strcpy(mensaje.remitente,mensaje.parametros);
		strcpy(mensaje.parametros,p+1);
		return modos(mode);
	}
	
	if(!strcmp(comando,"MODE")) return modos(mode);
	
        if(!strcmp(comando,"PRIVMSG")) {
        char buf[4*BUF_LEN];

		if(!strcasecmp2(mensaje.remitente,Nick)) { /* Mensaje al bot */
		char *p2,*p3;
		grupo_t *grupo;

			graba_log(linea);
			p=strchr(mensaje.parametros,' ');
			if(p==NULL) return mode;
			*p++='\0';
			while(*p==' ') p++;
			p2=strchr(p,' ');	/* Buscamos comando */
			if(p2==NULL) return mode;
			*p2++='\0';
			while(*p2==' ') p2++;
			p3=strchr(p2,' ');	/* Busca canal */
			if(p3!=NULL) {
				*p3++='\0';
				while(*p3==' ') p3++;
			} else {
				p3=p2+strlen(p2);
			}
			for(i=0;i<num_canales;i++)	/* Buscamos el canal */
				if(!strcasecmp2(p2,canales[i].nombre)) break;
			if(i>=num_canales) return mode;	/* Canal invlido */
			i=canales[i].privil;	/* Grupo privilegiado */
			if(i==-1) return mode;	/* No hay grupo privilegiado */
			grupo=&grupos[i];
			for(i=0;i<grupo->num_nicks;i++) { /* Buscamos clave */
				if(nicks[grupo->nicks[i]].clave==NULL) continue;
				if(!strcmp(mensaje.parametros+1,
					nicks[grupo->nicks[i]].clave))
					break;
			}
			if(i>=grupo->num_nicks) return mode;
			strcpy(mensaje.remitente,"");
			strcpy(mensaje.destinatario,p2); /* Canal */
			if(!strcasecmp2(p,"op")) {
				if(*p3=='\0') return mode;
				strcpy(mensaje.comando,"mode");
				strcpy(mensaje.parametros,"+o ");
				strcat(mensaje.parametros,p3); /* Usuario */
				p3=strchr(mensaje.parametros+3,' ');
				if(p3!=NULL) *p3='\0';
				p3=strchr(mensaje.parametros,'\t');
				if(p3!=NULL) *p3='\0';
				envia_msg();
				return mode;
			}
			if(!strcasecmp2(p,"deop")) {
				if(*p3=='\0') return mode;
				strcpy(mensaje.comando,"mode");
				strcpy(mensaje.parametros,"-o ");
				strcat(mensaje.parametros,p3); /* Usuario */
				p3=strchr(mensaje.parametros+3,' ');
				if(p3!=NULL) *p3='\0';
				p3=strchr(mensaje.parametros,'\t');
				if(p3!=NULL) *p3='\0';
				envia_msg();
				return mode;
			}
			if(!strcasecmp2(p,"invite")) {
				if(*p3=='\0') return mode;
				strcpy(mensaje.comando,p3);
				p3=strchr(mensaje.comando,' ');
				if(p3!=NULL) *p3='\0';
				p3=strchr(mensaje.comando,'\t');
				if(p3!=NULL) *p3='\0';
				strcpy(mensaje.parametros,mensaje.destinatario);
				strcpy(mensaje.destinatario,mensaje.comando);
				strcpy(mensaje.comando,"invite");
				envia_msg();
				return mode;			
			}
			if(!strcasecmp2(p,"unban")) { /* Pide la lista de bans */
				strcpy(mensaje.comando,"mode");
				strcpy(mensaje.parametros,"b");
				envia_msg();
				return mode;
			}
			return mode;
		}
                *strchr(mensaje.destinatario,'!')='\0';
                strcpy(buf,"<");
                strcat(buf,mensaje.destinatario+1);
                strcat(buf,"> ");
                strcat(buf,mensaje.parametros+1);
                strcat(buf,"\n");
                log_file(mensaje.remitente,buf);
                if((mensaje.remitente[0]=='#')||(mensaje.remitente[0]=='&')||
                	(mensaje.remitente[0]=='+')) {	/* Canal */
	                for(i=0;i<num_canales;i++)	/* Lazy Part */
	                	if(!strcasecmp2(mensaje.remitente,
	                		canales[i].nombre))
        	        		break;
        	       	if(i>=num_canales) {
	        	       	strcpy(mensaje.destinatario,mensaje.remitente);
        	       		strcpy(mensaje.remitente,"");
        	       		strcpy(mensaje.parametros,":Lazy Part...");
                		strcpy(mensaje.comando,"PART");
				envia_msg();
			}
                }
                return mode;
        }
	if(!strcmp(comando,"ERROR") || !comando[0]) {
		graba_log(linea);
		closesocket(soc);
		return RESTART;
	}
	if(!strcmp(comando,"NOTICE")) return notice(mode,linea);
	if(!strcmp(comando,"PING")) return ping(mode);
	if(!strcmp(comando,"312")) return mode;	/* Respuesta Whowas ignorada */
	if(!strcmp(comando,"314")) {	/* Respuesta Whowas */
		if(!(insistencia++))	/* Buscamos la IP */
			copia_campo(whowas,copia_campo(whowas,
				copia_campo(whowas,mensaje.parametros)));
		return mode;
	}
	if(!strcmp(comando,"369")) {	/* Fin del Whowas */
		printf("*** %s\n"
			"*** %d Accesos, de un mximo de %lu\n",
			whowas,insistencia,UMBRAL_KLINE);
		fflush(stdout);	
		if(insistencia>UMBRAL_KLINE) define_kline(whowas);
		insistencia=0;
		return mode;
	}
	if(!strcmp(comando,"433")) {	/* Un nick collide en segunda fase */
		graba_log(linea);
		mensaje.remitente[0]='\0';
		strcpy(mensaje.comando,"kill");
		strcpy(mensaje.destinatario,Nick);
		strcpy(mensaje.parametros,":");
		strcat(mensaje.parametros,IRCop_collide);
		envia_msg();
		strcpy(mensaje.comando,"nick");
		mensaje.parametros[0]='\0';
		envia_msg();
		sleep(5);
		return mode;
	}
	if(!strcmp(comando,"KICK")) {	/* Vuelve a entrar en el canal */
	char buf[BUF_LEN];
	
		strcpy(buf,mensaje.parametros);
		*strchr(buf,' ')='\0';
		
		if(!strcasecmp2(buf,Nick)) { /* Nosotros? */
			graba_log(linea);
			mass_join();
		}
		return mode;
	}

	if(!strcmp(comando,"JOIN")) {	/* Comprueba si hay Autoop */
		segmentacion(&n,mensaje.destinatario);
		if((n.usuario==NULL)||(n.dominio==NULL)) {
	/*
	** Tericamente no puede ocurrir nunca, pero ya
	** lo he visto un par de veces
	*/
			return mode;	/* Lo Ignoramos */
		}
		strcpy(n.nick,n.nick+1); /* Los ":" */
		for(i=0;i<num_canales;i++) {
			if(!strcasecmp2(canales[i].nombre,mensaje.parametros+1)) {
			
			/* 
			** Notice
			** No nos lo mandamos a nosotros mismos
			*/
				if((canales[i].notice!=NULL)&&
					(strcasecmp2(n.nick,Nick))) {
				char buf[BUF_LEN];
				
					mensaje.remitente[0]='\0';
					strcpy(mensaje.comando,"NOTICE");
				/* El destinatario ya viene puesto */
					strcpy(buf,mensaje.parametros);
					strcpy(mensaje.parametros+1,
						canales[i].notice);
					envia_msg();				
					strcpy(mensaje.parametros,buf);
				}
				
			/* AutoOp */
				j=canales[i].autoop;
				if(j==-1) return mode;	/* No hay AutoOp aqu */
				for(i=0;i<grupos[j].num_nicks;i++) {
					n2=&nicks[grupos[j].nicks[i]];
					if((n2->nick!=NULL)&&
						strcasecmp2(n2->nick,
						n.nick)) continue;
					if((n2->usuario!=NULL)&&
						strcasecmp2(n2->usuario,
							n.usuario)) continue;
					if((n2->dominio!=NULL)&&
						strcasecmp2(n2->dominio,
							n.dominio)) continue;
					strcpy(mensaje.remitente,"MODE");
					strcpy(mensaje.comando,mensaje.parametros+1);
					strcat(mensaje.comando," +o");
					strcpy(mensaje.parametros,"");
					envia_msg();
				}
				return mode;
			}				
		}
		if(i==num_canales) { /* Lazy Part */
			mensaje.remitente[0]='\0';
			strcpy(mensaje.comando,"PART");
			strcpy(mensaje.destinatario,mensaje.parametros+1);
			strcpy(mensaje.parametros+1,"Lazy Part...");
			envia_msg();
		}
		return mode;
	}
	if(!strcmp(comando,"372")) return mode;	/* MOTD */

#ifndef VERBOSE
	printf("%s\n",linea);
	fflush(stdout);	
#endif

	return mode;
}

/*
** Ante un notice, comprueba si es un kill de theilax. En ese caso se prepara
** el recuento del /whowas
*/

status notice(status mode,char *linea)
{
char buf[BUF_LEN];
static time_t tiempo=0;
time_t t;
	
/* Mira si es un mensaje enviado por nuestro servidor */
	if(strcmp(mensaje.destinatario+1,IRCop_servidor)) {	/* No lo es */
#ifndef VERBOSE
		printf("%s\n",linea);
		fflush(stdout);	
#endif
		return mode;
	}
	strcpy(buf,mensaje.parametros);
	buf[strlen(IRCop_kill)+1]='\0';	/* el +1 es por los ":" iniciales */
/* Mira si es un KILL. Nos saltamos los ":" iniciales */
	if(strcmp(buf+1,IRCop_kill)) {	/* No lo es */
#ifndef VERBOSE
		printf("%s\n",linea);
		fflush(stdout);	
#endif
		return mode;
	}
	t=time(NULL);
/* Mira si es de theilax */
	strcpy(buf,". From ");
	strcat(buf,IRCop_kill_serv);
	strcat(buf," Path: ");
	if(strstr(mensaje.parametros,buf)==NULL) {
#ifndef VERBOSE
		printf("%s\n",linea);
		fflush(stdout);	
#endif
		return mode;
	}
/*
** Es un kill de theilax. Lo siguiente es para no hacer muchos Whowas
*/
	if(!UMBRAL_KLINE) return mode;
	if(t-tiempo<TIMEOUT_WHOWAS) return mode;
	tiempo=t;
/*
** Obtenemos el nick a buscar.
** El +2 es por los ":" iniciales y el espacio final
*/
	copia_campo(buf,mensaje.parametros+strlen(IRCop_kill)+2);

	buf[strlen(buf)-1]='\0';
	mensaje.remitente[0]=mensaje.parametros[0]='\0';
	strcpy(mensaje.comando,"whowas");
	strcpy(mensaje.destinatario,buf);
	{
	char buf[BUF_LEN];
		
		sprintf(buf,"%lu",UMBRAL_KLINE+1);
		strcpy(mensaje.parametros,buf);
	}
	envia_msg();
	return mode;	
}

/*
** Resuelve el ping inicial. Pasa a modo operador, away, killea
** un posible nick collide.
*/
status ping(status mode)
{
	mensaje.comando[1]='O';
	envia_msg();
	if(mode==PING) {
	char buf[BUF_LEN];
	
		strcpy(buf,"oper ");
		strcat(buf,IRCop_nick);
		strcat(buf," ");
		strcat(buf,IRCop_clave);
		strcat(buf,"\n""kill ");
		strcat(buf,Nick);
		strcat(buf," :");
		strcat(buf,IRCop_collide);
		strcat(buf,"\n""nick ");
		strcat(buf,Nick);
		strcat(buf,"\n""mode ");
		strcat(buf,Nick);
		strcat(buf," k\n");	/* Channel Service */
		strcat(buf,"ping .\n");	/* Para saber cuando nos hemos registrado como K */
		send(soc,buf,strlen(buf),0);
		mode=REGISTRO_CS;
		envia_away();
	}
	return mode;
}
